\section{Global Optimization}

\subsection{Necessity}
\begin{frame}{Necessity}
	\begin{figure}
		\centering
		\input{img/why-global}
		\caption{Insufficiency of local optimization}
	\end{figure}
\end{frame}

\subsection{QosAgg}

\subsubsection{Example}
\begin{frame}[fragile]{QosAgg – Example}
	\begin{lstlisting}[language=qosagg, gobble=4, caption={Sample QosAgg workflow}]
		workflow {
			graph: A -> (B | C);

			aggregation cost: sum, sum;
			aggregation latency: sum, max;

			provision a4 for A: cost = 4, latency = 1;
			provision b2 for B: cost = 3, latency = 2;
			provision b3 for B: cost = 2, latency = 4;
			@…@
		}
	\end{lstlisting}
\end{frame}

\subsubsection{Big Picture}
\begin{frame}{QosAgg – Big Picture}
	\begin{figure}
		\resizebox{.9\textwidth}{!}{\input{img/architecture}}
		\caption{Architecture for global workflow optimization}
	\end{figure}
\end{frame}

\subsubsection{Additional Features}
\begin{frame}{QosAgg – Additional Features}
	\begin{itemize}
		\item Loops and Choices: \textit{\texttt{(A + B)\^{}5 -> (D?)}}
		\item Checkpoints: \textit{How much time is spent until task T starts?}
		\item Reachability: \textit{Is task T ever executed?}
		\item Categories: \textit{How many times do we switch the provider?}
		\item Variable attribute values: \textit{Should I use a subscription?}
	\end{itemize}
\end{frame}